version: '3.8'

x-shard: &django-base
  build:
    context: .
    dockerfile: ./compose/production/django/Dockerfile
  env_file:
    - ./.env.production
  environment:
    - DEBUG=off

services:
  nginx:
    build:
      context: .
      dockerfile: ./compose/production/nginx/Dockerfile
    ports:
      - 80:80
      - 443:443
    volumes:
      - certbot-etc:/etc/letsencrypt
      - certbot-var:/var/lib/letsencrypt
      - dhparam:/etc/ssl/certs

  django:
    <<: *django-base
    command: >
      bash -c "python /code/manage.py migrate --noinput &&
      python /code/manage.py collectstatic --noinput &&
      gunicorn {{ cookiecutter.project_slug }}.wsgi:application --error-logfile - --log-level info --timeout 120 --bind 0.0.0.0:8000"

  postgres:
    build:
      context: .
      dockerfile: ./compose/production/postgres/Dockerfile
    volumes:
      - production_postgres_data:/var/lib/postgresql/data:Z
      - production_postgres_data_backups:/backups:z
    env_file:
      - ./.env.production

  celery:
    <<: *django-base

  celery-beats:
    <<: *django-base

  certbot:
    image: certbot/certbot
    container_name: tm_bots_certbot
    volumes:
      - .:/code/:z
      - certbot-etc:/etc/letsencrypt
      - certbot-var:/var/lib/letsencrypt
    depends_on:
      - nginx
    command: certonly --webroot --webroot-path=/code/ --email po.service.mail@gmail.com --agree-tos --no-eff-email --force-renewal -d {{ cookiecutter.project_slug }}.com -d www.{{ cookiecutter.project_slug }}.com

volumes:
  certbot-etc:
  certbot-var:
  dhparam:
  production_postgres_data:
  production_postgres_data_backups: